#
# Please keep this package in sync with FC
#
# work around flakey gcc warnings
%{!?with_Werror: %global with_Werror 0}
%{!?with_sqlite: %global with_sqlite 0%{?fedora} >= 17 || 0%{?rhel} >= 7}
# prefer prebuilt docs
%{!?with_docs: %global with_docs 0}
%{!?with_htmldocs: %global with_htmldocs 0}
%{!?with_monitor: %global with_monitor 1}
# crash is not available
%ifarch ppc ppc64 %{sparc} %{mips} %{riscv}
%{!?with_crash: %global with_crash 0}
%else
  %if 0%{?mageia:1}
  # Linking fails due to a undefined symbols
  %{!?with_crash: %global with_crash 0}
  %else
  %{!?with_crash: %global with_crash 1}
  %endif
%endif
%{!?with_rpm: %global with_rpm 1}
%{!?elfutils_version: %global elfutils_version 0.179}
%{!?with_boost: %global with_boost 0}
%ifarch %{ix86} x86_64 ppc ppc64 ppc64le aarch64
%{!?with_dyninst: %global with_dyninst 0%{?fedora} >= 18 || 0%{?rhel} >= 7 || 0%{?mageia} >= 9}
%else
%{!?with_dyninst: %global with_dyninst 0}
%endif
%{!?with_bpf: %global with_bpf 0%{?fedora} >= 22 || 0%{?rhel} >= 8 || 0%{?mageia} >= 6}
%{!?with_systemd: %global with_systemd 0%{?fedora} >= 19 || 0%{?rhel} >= 7 || 0%{?mageia} >= 9}
%{!?with_emacsvim: %global with_emacsvim 0%{?fedora} >= 19 || 0%{?rhel} >= 7 || 0%{?mageia} >= 9}
%ifarch %{ix86} %{arm32}
%{!?with_java: %global with_java 0}
%else
%{!?with_java: %global with_java 0%{?fedora} >= 19 || 0%{?rhel} >= 7 || 0%{?mageia} >= 4}
%endif
%{!?with_debuginfod: %global with_debuginfod 0%{?fedora} >= 25 || 0%{?rhel} >= 7 || 0%{?mageia} >= 9 }
%{!?with_virthost: %global with_virthost 0%{?fedora} >= 19 || 0%{?rhel} >= 7 || 0%{?mageia} >= 5}
%{!?with_virtguest: %global with_virtguest 1}
%{!?with_dracut: %global with_dracut 0%{?fedora} >= 19 || 0%{?rhel} >= 6 || 0%{?mageia} >= 9}
%ifarch x86_64
%{!?with_mokutil: %global with_mokutil 0%{?fedora} >= 18 || 0%{?rhel} >= 7}
%{!?with_openssl: %global with_openssl 0%{?fedora} >= 18 || 0%{?rhel} >= 7}
%else
%{!?with_mokutil: %global with_mokutil 0}
%{!?with_openssl: %global with_openssl 0}
%endif
%{!?with_pyparsing: %global with_pyparsing 0%{?fedora} >= 18 || 0%{?rhel} >= 7 || 0%{?mageia} >= 5}
%{!?with_python3: %global with_python3 0%{?fedora} >= 23 || 0%{?rhel} > 7 || 0%{?mageia} >= 9}
%{!?with_python2_probes: %global with_python2_probes (0%{?fedora} <= 28 && 0%{?rhel} <= 7 && 0%{?mageia} < 8)}
%{!?with_python3_probes: %global with_python3_probes (0%{?fedora} >= 23 || 0%{?rhel} > 7 || 0%{?mageia} >= 5)}
%{!?with_httpd: %global with_httpd 0}
%{!?with_specific_python: %global with_specific_python 0%{?fedora} >= 31}
%{!?with_sysusers: %global with_sysusers 0%{?fedora} >= 32 || 0%{?rhel} >= 9 || 0%{?mageia} >= 9}

# Virt is supported on these arches, even on el7, but it's not in core EL7
%if 0%{?rhel} && 0%{?rhel} <= 7
%ifarch ppc64le aarch64
%global with_virthost 0
%endif
%endif

%if 0%{?fedora} >= 18 || 0%{?rhel} >= 6 || 0%{?mageia} >= 5
   %define initdir %{_initddir}
%else
   # RHEL5 doesn't know _initddir
   %define initdir %{_initrddir}
%endif

%if %{with_virtguest}
   %if 0%{?fedora} >= 18 || 0%{?rhel} >= 7  || 0%{?mageia} >= 5
      %define udevrulesdir /usr/lib/udev/rules.d
   %else
      %if 0%{?rhel} >= 6
         %define udevrulesdir /lib/udev/rules.d
      %endif
   %endif
%endif

%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7  || 0%{?mageia} >= 5
   %define dracutstap %{_prefix}/lib/dracut/modules.d/99stap
%else
   %define dracutstap %{_prefix}/share/dracut/modules.d/99stap
%endif

%if 0%{?rhel} == 6 || 0%{?rhel} == 7
    %define dracutbindir /sbin
%else
    %define dracutbindir %{_bindir}
%endif

%{!?_rpmmacrodir: %define _rpmmacrodir %{_rpmconfigdir}/macros.d}

%if 0%{?mageia:1}
# Filter file deps
%global __requires_exclude %{?__requires_exclude:__requires_exclude|}^%{_bindir}/(stap|tclsh)
%endif

# To avoid testsuite/*/*.stp has shebang which doesn't start with '/'
%define __brp_mangle_shebangs_exclude_from .stp$

%define _systemtap_runtime_preinstall \
# See systemd-sysusers(8) sysusers.d(5)\
\
g     stapusr  156\
g     stapsys  157\
g     stapdev  158\
g     stapunpriv 159\
u     stapunpriv 159      "systemtap unprivileged user"   /var/lib/stapunpriv   /sbin/nologin\
m     stapunpriv stapunpriv

%define _systemtap_server_preinstall \
# See systemd-sysusers(8) sysusers.d(5)\
\
g     stap-server  -\
u     stap-server  -      "systemtap compiler server"   /var/lib/stap-server   /sbin/nologin\
m     stap-server stap-server


%define _systemtap_testsuite_preinstall \
# See systemd-sysusers(8) sysusers.d(5)\
\
u     stapusr  -          "systemtap testsuite user"    /   /sbin/nologin\
u     stapsys  -          "systemtap testsuite user"    /   /sbin/nologin\
u     stapdev  -          "systemtap testsuite user"    /   /sbin/nologin\
m     stapusr  stapusr\
m     stapsys  stapusr\
m     stapsys  stapsys\
m     stapdev  stapusr\
m     stapdev  stapdev


Name: systemtap
Epoch: 1
Version: 5.2
Release: %mkrel 2
# for version, see also configure.ac


# Packaging abstract:
#
# systemtap              empty req:-client req:-devel
# systemtap-server       /usr/bin/stap-server*, req:-devel
# systemtap-devel        /usr/bin/stap, runtime, tapset, req:kernel-devel
# systemtap-runtime      /usr/bin/staprun, /usr/bin/stapsh, /usr/bin/stapdyn
# systemtap-client       /usr/bin/stap, samples, docs, tapset(bonus), req:-runtime
# systemtap-initscript   /etc/init.d/systemtap, dracut module, req:systemtap
# systemtap-sdt-devel    /usr/include/sys/sdt.h /usr/bin/dtrace
# systemtap-testsuite    /usr/share/systemtap/testsuite*, req:systemtap, req:sdt-devel
# systemtap-runtime-java libHelperSDT.so, HelperSDT.jar, stapbm, req:-runtime
# systemtap-runtime-virthost  /usr/bin/stapvirt, req:libvirt req:libxml2
# systemtap-runtime-virtguest udev rules, init scripts/systemd service, req:-runtime
# systemtap-runtime-python2 HelperSDT python2 module, req:-runtime
# systemtap-runtime-python3 HelperSDT python3 module, req:-runtime
# systemtap-jupyter      /usr/bin/stap-jupyter-* interactive-notebook req:systemtap
#
# Typical scenarios:
#
# stap-client:           systemtap-client
# stap-server:           systemtap-server
# local user:            systemtap
#
# Unusual scenarios:
#
# intermediary stap-client for --remote:       systemtap-client (-runtime unused)
# intermediary stap-server for --use-server:   systemtap-server (-devel unused)

Summary: Programmable system-wide instrumentation system
License: GPL-2.0-or-later
Group: Development/Kernel
URL: https://sourceware.org/systemtap/
Source: https://sourceware.org/systemtap/ftp/releases/%{name}-%{version}.tar.gz
Patch0: systemtap-4.6-fix-format.patch

# Build*
BuildRequires: make
BuildRequires: gcc-c++
BuildRequires: cpio
BuildRequires: gettext-devel
BuildRequires: pkgconfig(nss)
BuildRequires: pkgconfig(avahi-client)
%if %{with_debuginfod}
BuildRequires: pkgconfig(libdebuginfod)
BuildRequires: pkgconfig(json-c)
%endif
%if %{with_dyninst}
BuildRequires: dyninst-devel >= 10.0
BuildRequires: pkgconfig(libselinux)
%endif
%if %{with_sqlite}
BuildRequires: sqlite-devel > 3.7
%endif
%if %{with_monitor}
BuildRequires: pkgconfig(json-c)
BuildRequires: pkgconfig(ncurses)
%endif
%if %{with_systemd}
BuildRequires: systemd
%endif
# Needed for libstd++ < 4.0, without <tr1/memory>
%if %{with_boost}
BuildRequires: boost-devel
%endif
%if %{with_crash}
BuildRequires: crash-devel zlib-devel
%endif
%if %{with_rpm}
BuildRequires: rpm-devel
%endif
BuildRequires: elfutils-devel >= %{elfutils_version}
%if %{with_docs}
%if 0%{mageia} >= 9
BuildRequires: texlive ghostscript
%else
BuildRequires: /usr/bin/latex /usr/bin/dvips /usr/bin/ps2pdf
%endif
%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
BuildRequires: tex(fullpage.sty) tex(fancybox.sty) tex(bchr7t.tfm) tex(graphicx.sty)
%endif
%if %{with_htmldocs}
# On F10, xmlto's pdf support was broken off into a sub-package,
# called 'xmlto-tex'.  To avoid a specific F10 BuildReq, we'll do a
# file-based buildreq on '/usr/share/xmlto/format/fo/pdf'.
BuildRequires: xmlto /usr/share/xmlto/format/fo/pdf
%endif
%endif
%if %{with_emacsvim}
# for _emacs_sitelispdir macros etc.
BuildRequires: emacs
%endif
%if %{with_java}
BuildRequires: java-devel
%endif
%if %{with_virthost}
# BuildRequires: libvirt-devel >= 1.0.2
BuildRequires: pkgconfig(libvirt)
BuildRequires: pkgconfig(libxml-2.0)
%endif
BuildRequires: readline-devel
%if %{with_python2_probes}
BuildRequires: python2-devel
%if 0%{?fedora} >= 1
BuildRequires: python2-setuptools
%else
BuildRequires: python-setuptools
%endif
%endif
%if %{with_python3}
BuildRequires: python3
%endif
%if %{with_python3_probes}
BuildRequires: python3-devel
BuildRequires: python3-setuptools
%endif

%if %{with_httpd}
BuildRequires: libmicrohttpd-devel
BuildRequires: libuuid-devel
%endif
%if %{with_sysusers}
BuildRequires:  systemd-rpm-macros
%endif


# Install requirements
Requires: systemtap-client = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: systemtap-devel = %{?epoch:%{epoch}:}%{version}-%{release}

# mga9 -> mga10 upgrade:
Conflicts: systemtap-devel < 4.9-3.mga10

%description
SystemTap is an instrumentation system for systems running Linux.
Developers can write instrumentation scripts to collect data on
the operation of the system.  The base systemtap package contains/requires
the components needed to locally develop and execute systemtap scripts.

# ------------------------------------------------------------------------

%package server
Summary: Instrumentation System Server
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap-devel = %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-devel < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-runtime < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-client < %{?epoch:%{epoch}:}%{version}-%{release}
Requires: nss coreutils
Requires: zip unzip
Requires(pre): shadow-utils
%if 0%{?mageia:1}
BuildRequires: nss-devel avahi-client-devel
%else
BuildRequires: nss-devel avahi-devel
%endif
%if %{with_openssl}
Requires: openssl
%endif
%if %{with_systemd}
Requires: systemd
%else
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%endif

%description server
This is the remote script compilation server component of systemtap.
It announces itself to nearby clients with avahi (if available), and
compiles systemtap scripts to kernel objects on their demand.


%package devel
Summary: Programmable system-wide instrumentation system - development headers, tools
License: GPL-2.0-or-later AND GPL-2.0-only AND BSD-3-Clause AND LGPL-2.1-only AND BSD-2-Clause
URL: https://sourceware.org/systemtap/

%if 0%{?rhel} >= 8 || 0%{?fedora} >= 20
Recommends: (kernel-debug-devel if kernel-debug)
Recommends: (kernel-devel if kernel)
%elif 0%{?mageia} >= 9
Recommends: kernel-desktop-devel
%else
Requires: kernel-devel-uname-r
%endif

Requires: gcc make
# for compiling --runtime=dyninst sripts, need elfutils headers, bz1930973
Requires: elfutils-devel >= %{elfutils_version}

Conflicts: systemtap-client < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-server < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-runtime < %{?epoch:%{epoch}:}%{version}-%{release}
# Suggest: kernel-debuginfo

# mga9 -> mga10 upgrade:
Conflicts: %name < 4.9-3.mga10

%description devel
This package contains the components needed to compile a systemtap
script from source form into executable (.ko) forms.  It may be
installed on a self-contained developer workstation (along with the
systemtap-client and systemtap-runtime packages), or on a dedicated
remote server (alongside the systemtap-server package).  It includes
a copy of the standard tapset library and the runtime library C files.


%package runtime
Summary: Programmable system-wide instrumentation system - runtime
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires(pre): shadow-utils
Conflicts: systemtap-devel < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-server < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-client < %{?epoch:%{epoch}:}%{version}-%{release}

%description runtime
SystemTap runtime contains the components needed to execute
a systemtap script that was already compiled into a module
using a local or remote systemtap-devel installation.


%package client
Summary: Programmable system-wide instrumentation system - client
License: GPL-2.0-or-later AND GPL-2.0-only AND BSD-3-Clause AND LGPL-2.1-only AND GFDL-1.2-or-later AND BSD-2-Clause
URL: https://sourceware.org/systemtap/
Requires: zip unzip
Requires: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: coreutils grep sed unzip zip
Requires: openssh-clients
Conflicts: systemtap-devel < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-server < %{?epoch:%{epoch}:}%{version}-%{release}
Conflicts: systemtap-runtime < %{?epoch:%{epoch}:}%{version}-%{release}
%if %{with_mokutil}
Requires: mokutil
%endif

%description client
This package contains/requires only the components needed to
use systemtap scripts by compiling them using a local or a remote
systemtap-server service, then run them using a local or
remote systemtap-runtime.  It includes script samples and
documentation, and a copy of the tapset library for reference.


%package initscript
Summary: Systemtap Initscripts
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap = %{?epoch:%{epoch}:}%{version}-%{release}
%if %{with_systemd}
Requires: systemd
%else
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%endif

%description initscript
This package includes a SysVinit script to launch selected systemtap
scripts at system startup, along with a dracut module for early
boot-time probing if supported.


%package sdt-devel
Summary: Static probe support tools
Group: Development/Other
License: GPL-2.0-or-later AND CC0-1.0
URL: https://sourceware.org/systemtap/
%if %{with_pyparsing}
%if %{with_python3}
Requires: python3-pyparsing
%else
%if 0%{?rhel} >= 7
Requires: pyparsing
%else
Requires: python2-pyparsing
%endif
%endif
%endif

%description sdt-devel
This package includes the <sys/sdt.h> header file used for static
instrumentation compiled into userspace programs and libraries, along
with the optional dtrace-compatibility preprocessor to process related
.d files into tracing-macro-laden .h headers.


%package testsuite
Summary: Instrumentation System Testsuite
License: GPL-2.0-or-later AND GPL AND GPL-2.0-only AND GPL-3.0-or-later AND MIT
URL: https://sourceware.org/systemtap/
Requires: systemtap = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: systemtap-sdt-devel = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: systemtap-server = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: dejagnu which elfutils grep wget
%if %{with_debuginfod}
Requires: elfutils-debuginfod
%endif
# work around fedora ci gating kvetching about i686<->x86-64 conflicts
%ifarch x86_64
Conflicts: systemtap-testsuite = %{?epoch:%{epoch}:}%{version}-%{release}.i686
%endif
%ifarch i686
Conflicts: systemtap-testsuite = %{?epoch:%{epoch}:}%{version}-%{release}.x86_64
%endif
Requires: gcc gcc-c++ make glibc-devel
# testsuite/systemtap.base/ptrace.exp needs strace
Requires: strace
# testsuite/systemtap.base/ipaddr.exp needs nc. Unfortunately, the rpm
# that provides nc has changed over time (from 'nc' to
# 'nmap-ncat'). So, we'll do a file-based require.
%if 0%{?mageia} >= 9
Requires: netcat
%else
Requires: /usr/bin/nc
%endif
%ifnarch ia64 ppc64le aarch64
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8 || 0%{?mageia} >= 5
# no prelink
%else
Requires: prelink
%endif
%endif
# testsuite/systemtap.server/client.exp needs avahi
Requires: avahi
%if %{with_crash}
# testsuite/systemtap.base/crash.exp needs crash
Requires: crash
%endif
%if %{with_java}
Requires: systemtap-runtime-java = %{?epoch:%{epoch}:}%{version}-%{release}
%endif
%if %{with_python2_probes}
Requires: systemtap-runtime-python2 = %{?epoch:%{epoch}:}%{version}-%{release}
%endif
%if %{with_python3_probes}
Requires: systemtap-runtime-python3 = %{?epoch:%{epoch}:}%{version}-%{release}
%endif
%ifarch x86_64
%if 0%{?rhel} >= 8 || 0%{?fedora} >= 20
# fweimer, personal correspondence
Recommends: glibc-devel(x86-32)
%elif 0%{?mageia} >= 5
Requires: glibc-devel
%else
Requires: /usr/lib/libc.so
%endif
# ... and /usr/lib/libgcc_s.so.*
# ... and /usr/lib/libstdc++.so.*
%endif
%if 0%{?fedora} >= 18 || 0%{mageia} >= 5
Requires: stress
%endif
# The following "meta" files for the systemtap examples run "perf":
#   testsuite/systemtap.examples/hw_watch_addr.meta
#   testsuite/systemtap.examples/memory/hw_watch_sym.meta
Requires: perf

%description testsuite
This package includes the dejagnu-based systemtap stress self-testing
suite.  This may be used by system administrators to thoroughly check
systemtap on the current system.


%if %{with_java}
%package runtime-java
Summary: Systemtap Java Runtime Support
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}
# work around fedora ci gating kvetching about i686<->x86-64 conflicts
%ifarch x86_64
Conflicts: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}.i686
%endif
%ifarch i686
Conflicts: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}.x86_64
%endif
Requires: byteman > 2.0
Requires: iproute
Requires: java-devel

%description runtime-java
This package includes support files needed to run systemtap scripts
that probe Java processes running on the OpenJDK runtimes using Byteman.
%endif

%if %{with_python2_probes}
%package runtime-python2
Summary: Systemtap Python 2 Runtime Support
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}

%description runtime-python2
This package includes support files needed to run systemtap scripts
that probe python 2 processes.
%endif

%if %{with_python3_probes}
%package runtime-python3
Summary: Systemtap Python 3 Runtime Support
Group: Development/Python
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}

%if ! (%{with_python2_probes})
# Provide an clean upgrade path when the python2 package is removed
Obsoletes: %{name}-runtime-python2 < %{?epoch:%{epoch}:}%{version}-%{release}
%endif

%description runtime-python3
This package includes support files needed to run systemtap scripts
that probe python 3 processes.
%endif

%if %{with_python3_probes}
%package exporter
Summary: Systemtap-prometheus interoperation mechanism
Group: Development/Kernel
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}

%description exporter
This package includes files for a systemd service that manages
systemtap sessions and relays prometheus metrics from the sessions
to remote requesters on demand.
%endif

%if %{with_virthost}
%package runtime-virthost
Summary: Systemtap Cross-VM Instrumentation - host
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
# only require libvirt-libs really
#Requires: libvirt >= 1.0.2
Requires: libxml2

%description runtime-virthost
This package includes the components required to run systemtap scripts
inside a libvirt-managed domain from the host without using a network
connection.
%endif

%if %{with_virtguest}
%package runtime-virtguest
Summary: Systemtap Cross-VM Instrumentation - guest
Group: Development/Kernel
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap-runtime = %{?epoch:%{epoch}:}%{version}-%{release}
%if %{with_systemd}
Requires(post): findutils coreutils
Requires(preun): grep coreutils
Requires(postun): grep coreutils
%else
Requires(post): chkconfig initscripts
Requires(preun): chkconfig initscripts
Requires(postun): initscripts
%endif

%description runtime-virtguest
This package installs the services necessary on a virtual machine for a
systemtap-runtime-virthost machine to execute systemtap scripts.
%endif

%package jupyter
Summary: ISystemtap jupyter kernel and examples
License: GPL-2.0-or-later
URL: https://sourceware.org/systemtap/
Requires: systemtap = %{?epoch:%{epoch}:}%{version}-%{release}

%description jupyter
This package includes files needed to build and run
the interactive systemtap Jupyter kernel, either locally
or within a container.

# ------------------------------------------------------------------------

%prep
%setup -q
%patch -P 0 -p1

%build

# Enable/disable the dyninst pure-userspace backend
%if %{with_dyninst}
%global dyninst_config --with-dyninst
%else
%global dyninst_config --without-dyninst
%endif

# Enable/disable the dyninst pure-userspace backend
%if %{with_Werror}
%global Werror_config --enable-Werror
%else
%global Werror_config --disable-Werror
%endif

# Enable/disable the sqlite coverage testing support
%if %{with_sqlite}
%global sqlite_config --enable-sqlite
%else
%global sqlite_config --disable-sqlite
%endif

%if %{with_debuginfod}
%global debuginfod_config --with-debuginfod
%else
%global debuginfod_config --without-debuginfod
%endif


# Enable/disable the crash extension
%if %{with_crash}
%global crash_config --enable-crash
%else
%global crash_config --disable-crash
%endif

# Enable/disable the code to find and suggest needed rpms
%if %{with_rpm}
%global rpm_config --with-rpm
%else
%global rpm_config --without-rpm
%endif

%if %{with_docs}
%if %{with_htmldocs}
%global docs_config --enable-docs --enable-htmldocs
%else
%global docs_config --enable-docs --disable-htmldocs
%endif
%else
%global docs_config --enable-docs=prebuilt
%endif

%if %{with_java}
%global java_config --with-java=%{_jvmdir}/java
%else
%global java_config --without-java
%endif

%if %{with_python3}
%global python3_config --with-python3
%else
%global python3_config --without-python3
%endif
%if %{with_python2_probes}
%global python2_probes_config --with-python2-probes
%else
%global python2_probes_config --without-python2-probes
%endif
%if %{with_python3_probes}
%global python3_probes_config --with-python3-probes
%else
%global python3_probes_config --without-python3-probes
%endif

%if %{with_virthost}
%global virt_config --enable-virt
%else
%global virt_config --disable-virt
%endif

%if %{with_dracut}
%global dracut_config --with-dracutstap=%{dracutstap} --with-dracutbindir=%{dracutbindir}
%else
%global dracut_config %{nil}
%endif

%if %{with_httpd}
%global httpd_config --enable-httpd
%else
%global httpd_config --disable-httpd
%endif

%if %{with_bpf}
%global bpf_config --with-bpf
%else
%global bpf_config --without-bpf
%endif

# We don't ship compileworthy python code, just oddball samples
%global py_auto_byte_compile 0

%configure %{Werror_config} %{dyninst_config} %{sqlite_config} %{crash_config} %{docs_config} %{rpm_config} %{java_config} %{virt_config} %{dracut_config} %{python3_config} %{python2_probes_config} %{python3_probes_config} %{httpd_config} %{bpf_config} %{debuginfod_config} --disable-silent-rules --with-extra-version="rpm %{version}-%{release}"
make %{?_smp_mflags} V=1


%install
make DESTDIR=$RPM_BUILD_ROOT install

%if ! (%{with_python3})
rm -v $RPM_BUILD_ROOT%{_bindir}/stap-profile-annotate
%endif

%find_lang %{name}
for dir in $(ls -1d $RPM_BUILD_ROOT%{_mandir}/{??,??_??}) ; do
    dir=$(echo $dir | sed -e "s|^$RPM_BUILD_ROOT||")
    lang=$(basename $dir)
    echo "%%lang($lang) $dir/man*/*" >> %{name}.lang
done

%if %{with_sysusers}
mkdir -p %{buildroot}%{_sysusersdir}
echo '%_systemtap_runtime_preinstall' > %{buildroot}%{_sysusersdir}/systemtap-runtime.conf
echo '%_systemtap_server_preinstall' > %{buildroot}%{_sysusersdir}/systemtap-server.conf
echo '%_systemtap_testsuite_preinstall' > %{buildroot}%{_sysusersdir}/systemtap-testsuite.conf
%endif


ln -s %{_datadir}/systemtap/examples

# Fix paths in the example scripts.
find $RPM_BUILD_ROOT%{_datadir}/systemtap/examples -type f -name '*.stp' -print0 | xargs -0 sed -i -r -e '1s@^#!.+stap@#!%{_bindir}/stap@'

# To make rpmlint happy, remove any .gitignore files in the testsuite.
find testsuite -type f -name '.gitignore' -print0 | xargs -0 rm -f

# Because "make install" may install staprun with whatever mode, the
# post-processing programs rpmbuild runs won't be able to read it.
# So, we change permissions so that they can read it.  We'll set the
# permissions back to 04110 in the %files section below.
chmod 755 $RPM_BUILD_ROOT%{_bindir}/staprun

#install the useful stap-prep script
install -c -m 755 stap-prep $RPM_BUILD_ROOT%{_bindir}/stap-prep

# Copy over the testsuite
cp -rp testsuite $RPM_BUILD_ROOT%{_datadir}/systemtap

# We want the manuals in the special doc dir, not the generic doc install dir.
# We build it in place and then move it away so it doesn't get installed
# twice. rpm can specify itself where the (versioned) docs go with the
# %doc directive.
mkdir docs.installed
mv $RPM_BUILD_ROOT%{_datadir}/doc/systemtap/*.pdf docs.installed/
%if %{with_docs}
%if %{with_htmldocs}
mv $RPM_BUILD_ROOT%{_datadir}/doc/systemtap/tapsets docs.installed/
mv $RPM_BUILD_ROOT%{_datadir}/doc/systemtap/SystemTap_Beginners_Guide docs.installed/
%endif
%endif

install -D -m 644 macros.systemtap $RPM_BUILD_ROOT%{_rpmmacrodir}/macros.systemtap

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/stap-server
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/stap-server
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/stap-server/.systemtap
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/stap-server
touch $RPM_BUILD_ROOT%{_localstatedir}/log/stap-server/log
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/cache/systemtap
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run/systemtap
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -m 644 initscript/logrotate.stap-server $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/stap-server

# If using systemd systemtap.service file, retain the old init script in %{_libexecdir} as a helper.
%if %{with_systemd}
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
touch $RPM_BUILD_ROOT%{_unitdir}/systemtap.service
# RHBZ2070857
mkdir -p $RPM_BUILD_ROOT%{_presetdir}
echo 'enable systemtap.service' > $RPM_BUILD_ROOT%{_presetdir}/42-systemtap.preset
install -m 644 initscript/systemtap.service $RPM_BUILD_ROOT%{_unitdir}/systemtap.service
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
install -m 755 initscript/systemtap $RPM_BUILD_ROOT%{_sbindir}/systemtap-service
%else
mkdir -p $RPM_BUILD_ROOT%{initdir}
install -m 755 initscript/systemtap $RPM_BUILD_ROOT%{initdir}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
ln -sf %{initdir}/systemtap $RPM_BUILD_ROOT%{_sbindir}/systemtap-service
# TODO CHECK CORRECTNESS: symlink %{_sbindir}/systemtap-service to %{initdir}/systemtap
%endif

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/systemtap
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/systemtap/conf.d
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/systemtap/script.d
install -m 644 initscript/config.systemtap $RPM_BUILD_ROOT%{_sysconfdir}/systemtap/config

%if %{with_systemd}
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
touch $RPM_BUILD_ROOT%{_unitdir}/stap-server.service
install -m 644 stap-server.service $RPM_BUILD_ROOT%{_unitdir}/stap-server.service
mkdir -p $RPM_BUILD_ROOT%{_tmpfilesdir}
install -m 644 stap-server.conf $RPM_BUILD_ROOT%{_tmpfilesdir}/stap-server.conf
%else
install -m 755 initscript/stap-server $RPM_BUILD_ROOT%{initdir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/stap-server/conf.d
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 644 initscript/config.stap-server $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/stap-server
%endif

%if %{with_emacsvim}
mkdir -p $RPM_BUILD_ROOT%{_emacs_sitelispdir}
install -p -m 644 emacs/systemtap-mode.el* $RPM_BUILD_ROOT%{_emacs_sitelispdir}
mkdir -p $RPM_BUILD_ROOT%{_emacs_sitestartdir}
install -p -m 644 emacs/systemtap-init.el $RPM_BUILD_ROOT%{_emacs_sitestartdir}/systemtap-init.el
for subdir in ftdetect ftplugin indent syntax
do
    mkdir -p $RPM_BUILD_ROOT%{_datadir}/vim/vimfiles/$subdir
    install -p -m 644 vim/$subdir/*.vim $RPM_BUILD_ROOT%{_datadir}/vim/vimfiles/$subdir
done
%endif

%if %{with_virtguest}
   mkdir -p $RPM_BUILD_ROOT%{udevrulesdir}
   %if %{with_systemd}
      install -p -m 644 staprun/guest/99-stapsh.rules $RPM_BUILD_ROOT%{udevrulesdir}
      mkdir -p $RPM_BUILD_ROOT%{_unitdir}
      install -p -m 644 staprun/guest/stapsh@.service $RPM_BUILD_ROOT%{_unitdir}
   %else
      install -p -m 644 staprun/guest/99-stapsh-init.rules $RPM_BUILD_ROOT%{udevrulesdir}
      install -p -m 755 staprun/guest/stapshd $RPM_BUILD_ROOT%{initdir}
      mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/systemtap
      install -p -m 755 staprun/guest/stapsh-daemon $RPM_BUILD_ROOT%{_libexecdir}/systemtap
      mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/modules
      # Technically, this is only needed for RHEL5, in which the MODULE_ALIAS is missing, but
      # it does no harm in RHEL6 as well
      install -p -m 755 staprun/guest/virtio_console.modules $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/modules
   %endif
%endif

%if %{with_dracut}
   mkdir -p $RPM_BUILD_ROOT%{dracutstap}
   install -p -m 755 initscript/99stap/module-setup.sh $RPM_BUILD_ROOT%{dracutstap}
   install -p -m 755 initscript/99stap/install $RPM_BUILD_ROOT%{dracutstap}
   install -p -m 755 initscript/99stap/check $RPM_BUILD_ROOT%{dracutstap}
   install -p -m 755 initscript/99stap/start-staprun.sh $RPM_BUILD_ROOT%{dracutstap}
   touch $RPM_BUILD_ROOT%{dracutstap}/params.conf
%endif

%if %{with_specific_python}
# Some files got ambiguous python shebangs, we fix them after everything else is done
%py3_shebang_fix %{buildroot}%{python3_sitearch} %{buildroot}%{_bindir}/*
%endif

%pre runtime
%if %{with_sysusers}
echo '%_systemtap_runtime_preinstall' | systemd-sysusers --replace=%{_sysusersdir}/systemtap-runtime.conf -
%else
getent group stapusr >/dev/null || groupadd -f -g 156 -r stapusr
getent group stapsys >/dev/null || groupadd -f -g 157 -r stapsys
getent group stapdev >/dev/null || groupadd -f -g 158 -r stapdev
getent passwd stapunpriv >/dev/null || \
  useradd -c "Systemtap Unprivileged User" -u 159 -g stapunpriv -d %{_localstatedir}/lib/stapunpriv -r -s /sbin/nologin stapunpriv 2>/dev/null || \
  useradd -c "Systemtap Unprivileged User" -g stapunpriv -d %{_localstatedir}/lib/stapunpriv -r -s /sbin/nologin stapunpriv
%endif
exit 0

%pre server
%if %{with_sysusers}
echo '%_systemtap_server_preinstall' | systemd-sysusers --replace=%{_sysusersdir}/systemtap-server.conf -
%else
getent group stap-server >/dev/null || groupadd -f -g 155 -r stap-server
getent passwd stap-server >/dev/null || \
  useradd -c "Systemtap Compile Server" -u 155 -g stap-server -d %{_localstatedir}/lib/stap-server -r -s /sbin/nologin stap-server 2>/dev/null || \
  useradd -c "Systemtap Compile Server" -g stap-server -d %{_localstatedir}/lib/stap-server -r -s /sbin/nologin stap-server
%endif
exit 0

%pre testsuite
%if %{with_sysusers}
echo '%_systemtap_testsuite_preinstall' | systemd-sysusers --replace=%{_sysusersdir}/systemtap-testsuite.conf -
%else
getent passwd stapusr >/dev/null || \
    useradd -c "Systemtap 'stapusr' User" -g stapusr -r -s /sbin/nologin stapusr
getent passwd stapsys >/dev/null || \
    useradd -c "Systemtap 'stapsys' User" -g stapsys -G stapusr -r -s /sbin/nologin stapsys
getent passwd stapdev >/dev/null || \
    useradd -c "Systemtap 'stapdev' User" -g stapdev -G stapusr -r -s /sbin/nologin stapdev
%endif
exit 0

%post server

# We have some duplication between the %files listings for the
# ~stap-server directories and the explicit mkdir/chown/chmod bits
# here.  Part of the reason may be that a preexisting stap-server
# account may well be placed somewhere other than
# %{_localstatedir}/lib/stap-server, but we'd like their permissions
# set similarly.

test -e ~stap-server && chmod 750 ~stap-server

if [ ! -f ~stap-server/.systemtap/rc ]; then
  mkdir -p ~stap-server/.systemtap
  chown stap-server:stap-server ~stap-server/.systemtap
  # PR16276: guess at a reasonable number for a default --rlimit-nproc
  numcpu=`/usr/bin/getconf _NPROCESSORS_ONLN`
  if [ -z "$numcpu" -o "$numcpu" -lt 1 ]; then numcpu=1; fi
  nproc=`expr $numcpu \* 30`
  # PR29661 -> 4G
  echo "--rlimit-as=4294967296 --rlimit-cpu=60 --rlimit-nproc=$nproc --rlimit-stack=1024000 --rlimit-fsize=51200000" > ~stap-server/.systemtap/rc
  chown stap-server:stap-server ~stap-server/.systemtap/rc
fi

test -e %{_localstatedir}/log/stap-server/log || {
     touch %{_localstatedir}/log/stap-server/log
     chmod 644 %{_localstatedir}/log/stap-server/log
     chown stap-server:stap-server %{_localstatedir}/log/stap-server/log
}
# Prepare the service
%if %{with_systemd}
     # Note, Fedora policy doesn't allow network services enabled by default
     # /bin/systemctl enable stap-server.service >/dev/null 2>&1 || :
     /bin/systemd-tmpfiles --create %{_tmpfilesdir}/stap-server.conf >/dev/null 2>&1 || :
%else
    /sbin/chkconfig --add stap-server
%endif
exit 0

%triggerin client -- systemtap-server
if test -e ~stap-server/.systemtap/ssl/server/stap.cert; then
   # echo Authorizing ssl-peer/trusted-signer certificate for local systemtap-server
   %{_libexecdir}/systemtap/stap-authorize-cert ~stap-server/.systemtap/ssl/server/stap.cert %{_sysconfdir}/systemtap/ssl/client >/dev/null
   %{_libexecdir}/systemtap/stap-authorize-cert ~stap-server/.systemtap/ssl/server/stap.cert %{_sysconfdir}/systemtap/staprun >/dev/null
fi
exit 0
# XXX: corresponding %triggerun?

%preun server
# Check that this is the actual deinstallation of the package, as opposed to
# just removing the old package on upgrade.
if [ $1 = 0 ] ; then
    %if %{with_systemd}
       /bin/systemctl --no-reload disable stap-server.service >/dev/null 2>&1 || :
       /bin/systemctl stop stap-server.service >/dev/null 2>&1 || :
    %else
        /sbin/service stap-server stop >/dev/null 2>&1
        /sbin/chkconfig --del stap-server
    %endif
fi
exit 0

%postun server
# Check whether this is an upgrade of the package.
# If so, restart the service if it's running
if [ "$1" -ge "1" ] ; then
    %if %{with_systemd}
        /bin/systemctl condrestart stap-server.service >/dev/null 2>&1 || :
    %else
        /sbin/service stap-server condrestart >/dev/null 2>&1 || :
    %endif
fi
exit 0

%post initscript
%if %{with_systemd}
    # RHBZ2070857 - use systemd presets instead
    # /bin/systemctl enable systemtap.service >/dev/null 2>&1 || :
%else
    /sbin/chkconfig --add systemtap
%endif
exit 0

%preun initscript
# Check that this is the actual deinstallation of the package, as opposed to
# just removing the old package on upgrade.
if [ $1 = 0 ] ; then
    %if %{with_systemd}
        /bin/systemctl --no-reload disable systemtap.service >/dev/null 2>&1 || :
        /bin/systemctl stop systemtap.service >/dev/null 2>&1 || :
    %else
        /sbin/service systemtap stop >/dev/null 2>&1
        /sbin/chkconfig --del systemtap
    %endif
fi
exit 0

%postun initscript
# Check whether this is an upgrade of the package.
# If so, restart the service if it's running
if [ "$1" -ge "1" ] ; then
    %if %{with_systemd}
        /bin/systemctl condrestart systemtap.service >/dev/null 2>&1 || :
    %else
        /sbin/service systemtap condrestart >/dev/null 2>&1 || :
    %endif
fi
exit 0

%post runtime-virtguest
%if %{with_systemd}
   # Start services if there are ports present
   if [ -d /dev/virtio-ports ]; then
      (find /dev/virtio-ports -iname 'org.systemtap.stapsh.[0-9]*' -type l \
         | xargs -n 1 basename \
         | xargs -n 1 -I {} /bin/systemctl start stapsh@{}.service) >/dev/null 2>&1 || :
   fi
%else
   /sbin/chkconfig --add stapshd
   /sbin/chkconfig stapshd on
   /sbin/service stapshd start >/dev/null 2>&1 || :
%endif
exit 0

%preun runtime-virtguest
# Stop service if this is an uninstall rather than an upgrade
if [ $1 = 0 ]; then
   %if %{with_systemd}
      # We need to stop all stapsh services. Because they are instantiated from
      # a template service file, we can't simply call disable. We need to find
      # all the running ones and stop them all individually
      for service in `/bin/systemctl --full | grep stapsh@ | cut -d ' ' -f 1`; do
         /bin/systemctl stop $service >/dev/null 2>&1 || :
      done
   %else
      /sbin/service stapshd stop >/dev/null 2>&1
      /sbin/chkconfig --del stapshd
   %endif
fi
exit 0

%postun runtime-virtguest
# Restart service if this is an upgrade rather than an uninstall
if [ "$1" -ge "1" ]; then
   %if %{with_systemd}
      # We need to restart all stapsh services. Because they are instantiated from
      # a template service file, we can't simply call restart. We need to find
      # all the running ones and restart them all individually
      for service in `/bin/systemctl --full | grep stapsh@ | cut -d ' ' -f 1`; do
         /bin/systemctl condrestart $service >/dev/null 2>&1 || :
      done
   %else
      /sbin/service stapshd condrestart >/dev/null 2>&1
   %endif
fi
exit 0

%if %{with_python3_probes}
%if %{with_systemd}
%preun exporter
if [ $1 = 0 ] ; then
  /bin/systemctl stop stap-exporter.service >/dev/null 2>&1 || :
  /bin/systemctl disable stap-exporter.service >/dev/null 2>&1 || :
fi
exit 0

%postun exporter
# Restart service if this is an upgrade rather than an uninstall
if [ "$1" -ge "1" ]; then
   /bin/systemctl condrestart stap-exporter >/dev/null 2>&1 || :
fi
exit 0
%endif
%endif

%post
# Remove any previously-built uprobes.ko materials
(make -C %{_datadir}/systemtap/runtime/uprobes clean) >/dev/null 2>&1 || true
(/sbin/rmmod uprobes) >/dev/null 2>&1 || true

%preun
# Ditto
(make -C %{_datadir}/systemtap/runtime/uprobes clean) >/dev/null 2>&1 || true
(/sbin/rmmod uprobes) >/dev/null 2>&1 || true

# ------------------------------------------------------------------------

%files
# The main "systemtap" rpm doesn't include any files.

%files server -f systemtap.lang
%{_bindir}/stap-server
%dir %{_libexecdir}/systemtap
%{_libexecdir}/systemtap/stap-serverd
%{_libexecdir}/systemtap/stap-start-server
%{_libexecdir}/systemtap/stap-stop-server
%{_libexecdir}/systemtap/stap-gen-cert
%{_libexecdir}/systemtap/stap-sign-module
%{_libexecdir}/systemtap/stap-authorize-cert
%{_libexecdir}/systemtap/stap-env
%{_mandir}/man7/error*
%{_mandir}/man7/stappaths.7*
%{_mandir}/man7/warning*
%{_mandir}/man8/stap-server.8*
%if %{with_systemd}
%{_unitdir}/stap-server.service
%{_tmpfilesdir}/stap-server.conf
%else
%{initdir}/stap-server
%dir %{_sysconfdir}/stap-server/conf.d
%config(noreplace) %{_sysconfdir}/sysconfig/stap-server
%endif
%config(noreplace) %{_sysconfdir}/logrotate.d/stap-server
%dir %{_sysconfdir}/stap-server
%dir %attr(0750,stap-server,stap-server) %{_localstatedir}/lib/stap-server
%dir %attr(0700,stap-server,stap-server) %{_localstatedir}/lib/stap-server/.systemtap
%dir %attr(0755,stap-server,stap-server) %{_localstatedir}/log/stap-server
%ghost %config(noreplace) %attr(0644,stap-server,stap-server) %{_localstatedir}/log/stap-server/log
%ghost %attr(0755,stap-server,stap-server) %{_localstatedir}/run/stap-server
%doc README README.unprivileged AUTHORS NEWS 
%{!?_licensedir:%global license %%doc}
%license COPYING
%if %{with_sysusers}
%{_sysusersdir}/systemtap-server.conf
%endif


%files devel -f systemtap.lang
%{_bindir}/stap
%{_bindir}/stap-prep
%if %{with_python3}
%{_bindir}/stap-profile-annotate
%endif
%{_bindir}/stap-report
%dir %{_datadir}/systemtap
%{_datadir}/systemtap/runtime
%{_datadir}/systemtap/tapset
%{_mandir}/man1/stap.1*
%{_mandir}/man1/stap-prep.1*
%{_mandir}/man1/stap-report.1*
%{_mandir}/man7/error*
%{_mandir}/man7/stappaths.7*
%{_mandir}/man7/warning*
%doc README README.unprivileged AUTHORS NEWS 
%{!?_licensedir:%global license %%doc}
%license COPYING
%if %{with_java}
%dir %{_libexecdir}/systemtap
%{_libexecdir}/systemtap/libHelperSDT.so
%endif
%if %{with_emacsvim}
%{_emacs_sitelispdir}/*.el*
%{_emacs_sitestartdir}/systemtap-init.el
%{_datadir}/vim/vimfiles/*/*.vim
%endif
# Notice that the stap-resolve-module-function.py file is used by
# *both* the python2 and python3 subrpms.  Both subrpms use that same
# python script to help list python probes.
%if %{with_python3_probes} || %{with_python2_probes}
%{_libexecdir}/systemtap/python/stap-resolve-module-function.py
%exclude %{_libexecdir}/systemtap/python/stap-resolve-module-function.py?
%endif


%files runtime -f systemtap.lang
%attr(4110,root,stapusr) %{_bindir}/staprun
%{_bindir}/stapsh
%{_bindir}/stap-merge
%{_bindir}/stap-report
%if %{with_dyninst}
%{_bindir}/stapdyn
%endif
%if %{with_bpf}
%{_bindir}/stapbpf
%endif
%dir %{_libexecdir}/systemtap
%{_libexecdir}/systemtap/stapio
%{_libexecdir}/systemtap/stap-authorize-cert
%if %{with_crash}
%dir %{_libdir}/systemtap
%{_libdir}/systemtap/staplog.so*
%endif
%{_mandir}/man1/stap-report.1*
%{_mandir}/man7/error*
%{_mandir}/man7/stappaths.7*
%{_mandir}/man7/warning*
%{_mandir}/man8/stapsh.8*
%{_mandir}/man8/staprun.8*
%if %{with_dyninst}
%{_mandir}/man8/stapdyn.8*
%endif
%if %{with_bpf}
%{_mandir}/man8/stapbpf.8*
%endif
%doc README README.security AUTHORS NEWS 
%{!?_licensedir:%global license %%doc}
%license COPYING
%if %{with_sysusers}
%{_sysusersdir}/systemtap-runtime.conf
%endif


%files client -f systemtap.lang
%doc README README.unprivileged AUTHORS NEWS
%{_datadir}/systemtap/examples
%{!?_licensedir:%global license %%doc}
%license COPYING
%doc docs.installed/*.pdf
%if %{with_docs}
%if %{with_htmldocs}
%doc docs.installed/tapsets/*.html
%doc docs.installed/SystemTap_Beginners_Guide
%endif
%endif
%{_bindir}/stap
%{_bindir}/stap-prep
%{_bindir}/stap-report
%{_mandir}/man1/stap.1*
%{_mandir}/man1/stap-prep.1*
%{_mandir}/man1/stap-merge.1*
%{_mandir}/man1/stap-report.1*
%{_mandir}/man1/stapref.1*
%{_mandir}/man3/*
%{_mandir}/man7/error*
%{_mandir}/man7/stappaths.7*
%{_mandir}/man7/warning*
%dir %{_datadir}/systemtap
%{_datadir}/systemtap/tapset



%files initscript
%if %{with_systemd}
%{_presetdir}/42-systemtap.preset
%{_unitdir}/systemtap.service
%{_sbindir}/systemtap-service
%else
%{initdir}/systemtap
%{_sbindir}/systemtap-service
%endif
%dir %{_sysconfdir}/systemtap
%dir %{_sysconfdir}/systemtap/conf.d
%dir %{_sysconfdir}/systemtap/script.d
%config(noreplace) %{_sysconfdir}/systemtap/config
%dir %{_localstatedir}/cache/systemtap
%ghost %{_localstatedir}/run/systemtap
%{_mandir}/man8/systemtap-service.8*
%if %{with_dracut}
   %dir %{dracutstap}
   %{dracutstap}/*
%endif


%files sdt-devel
%{_bindir}/dtrace
%{_includedir}/sys/sdt.h
%{_includedir}/sys/sdt-config.h
%{_mandir}/man1/dtrace.1*
%{_rpmmacrodir}/macros.systemtap
%doc README AUTHORS NEWS 
%{!?_licensedir:%global license %%doc}
%license COPYING


%files testsuite
%dir %{_datadir}/systemtap
%{_datadir}/systemtap/testsuite
%if %{with_sysusers}
%{_sysusersdir}/systemtap-testsuite.conf
%endif


%if %{with_java}
%files runtime-java
%dir %{_libexecdir}/systemtap
%{_libexecdir}/systemtap/libHelperSDT.so
%{_libexecdir}/systemtap/HelperSDT.jar
%{_libexecdir}/systemtap/stapbm
%endif

%if %{with_python2_probes}
%files runtime-python2
%{python_sitearch}/HelperSDT
%{python_sitearch}/HelperSDT-*.egg-info
%endif
%if %{with_python3_probes}
%files runtime-python3
%{python3_sitearch}/HelperSDT
%{python3_sitearch}/HelperSDT-*.egg-info
%endif

%if %{with_virthost}
%files runtime-virthost
%{_mandir}/man1/stapvirt.1*
%{_bindir}/stapvirt
%endif

%if %{with_virtguest}
%files runtime-virtguest
%if %{with_systemd}
   %{udevrulesdir}/99-stapsh.rules
   %{_unitdir}/stapsh@.service
%else
   %{udevrulesdir}/99-stapsh-init.rules
   %dir %{_libexecdir}/systemtap
   %{_libexecdir}/systemtap/stapsh-daemon
   %{initdir}/stapshd
   %{_sysconfdir}/sysconfig/modules/virtio_console.modules
%endif
%endif

%if %{with_python3_probes}
%files exporter
%{_sysconfdir}/stap-exporter
%{_sysconfdir}/sysconfig/stap-exporter
%{_unitdir}/stap-exporter.service
%{_mandir}/man8/stap-exporter.8*
%{_sbindir}/stap-exporter
%endif

%files jupyter
%{_bindir}/stap-jupyter-container
%{_bindir}/stap-jupyter-install
%{_mandir}/man1/stap-jupyter.1*
%dir %{_datadir}/systemtap
%{_datadir}/systemtap/interactive-notebook



%changelog
* Sun Feb 09 2025 wally <wally> 1:5.2-2.mga10
+ Revision: 2146279
- rebuild for boost 1.87.0

* Sat Nov 09 2024 daviddavid <daviddavid> 1:5.2-1.mga10
+ Revision: 2113315
- new version: 5.2
- fix dependencies: we don't provides prelink and nc

* Sun Nov 03 2024 wally <wally> 1:5.1-6.mga10
+ Revision: 2112255
- sync .spec again with Fedora as much as possible

* Sun Nov 03 2024 wally <wally> 1:5.1-5.mga10
+ Revision: 2112221
- rebuild with new libdebuginfod splitted out in elfutils 0.192

* Fri Sep 13 2024 wally <wally> 1:5.1-4.mga10
+ Revision: 2095528
- rebuild for boost 1.86.0

* Wed Jun 19 2024 wally <wally> 1:5.1-3.mga10
+ Revision: 2075398
- rebuild for boost 1.85.0

* Sat Jun 01 2024 daviddavid <daviddavid> 1:5.1-2.mga10
+ Revision: 2069121
- new version: 5.1

* Fri Jan 12 2024 wally <wally> 1:5.0-3.mga10
+ Revision: 2030600
- rebuild for boost 1.84.0

* Fri Dec 29 2023 tv <tv> 1:5.0-2.mga10
+ Revision: 2023427
- Add conflicts in order to help upgrade

* Thu Dec 28 2023 tv <tv> 1:5.0-1.mga10
+ Revision: 2023387
- 5.0, see wiki page below for detailed notes.
  https://sourceware.org/systemtap/wiki/SystemTapReleases

* Sun Nov 12 2023 daviddavid <daviddavid> 1:4.9-2.mga10
+ Revision: 2006266
- rebuild for new rpm 4.19.0

* Thu Sep 28 2023 tv <tv> 1:4.9-1.mga10
+ Revision: 1991912
- 4.9, see wiki page below for detailed notes.
  https://sourceware.org/systemtap/wiki/SystemTapReleases

* Wed Sep 27 2023 wally <wally> 1:4.8-4.mga10
+ Revision: 1991504
- rebuild for boost 1.83.0

* Sun Sep 17 2023 daviddavid <daviddavid> 1:4.8-3.mga10
+ Revision: 1987424
- rebuild for new dyninst 12.3.0

* Sat Dec 24 2022 wally <wally> 1:4.8-2.mga9
+ Revision: 1926534
- rebuild for boost 1.81.0

* Tue Nov 08 2022 tv <tv> 1:4.8-1.mga9
+ Revision: 1904623
- 4.8

* Sun Jul 03 2022 wally <wally> 1:4.7-2.mga9
+ Revision: 1867315
- rebuild for boost 1.79.0

* Tue May 03 2022 tv <tv> 1:4.7-1.mga9
+ Revision: 1855627
- Upstream release 4.7, see wiki page below for detailed notes.
  https://sourceware.org/systemtap/wiki/SystemTapReleases

* Tue Mar 22 2022 tmb <tmb> 1:4.6-10.mga9
+ Revision: 1818285
- really apply patch5 for: arm: set STAP_SDT_ARG_CONSTRAINT=g

* Thu Mar 17 2022 pterjan <pterjan> 1:4.6-9.mga9
+ Revision: 1797447
- Add upstream patch to fix the build on various packages on arm (https://gcc.gnu.org/bugzilla/show_bug.cgi?id=103395)

* Mon Mar 14 2022 tv <tv> 1:4.6-8.mga9
+ Revision: 1791032
- Fix building with gcc-12
- Rebuild for new dyninst
+ joequant <joequant>
- rebuild

* Sat Feb 12 2022 tv <tv> 1:4.6-5.mga9
+ Revision: 1773355
- Rebuild for python-3.10

* Tue Jan 11 2022 tv <tv> 1:4.6-4.mga9
+ Revision: 1767955
- Rebuild for dyninst-12.0.1

* Sat Jan 01 2022 guillomovitch <guillomovitch> 1:4.6-3.mga9
+ Revision: 1766012
- fix format error preventing build
+ wally <wally>
- rebuild for boost 1.78.0
+ luigiwalser <luigiwalser>
- 4.6

* Thu Sep 09 2021 wally <wally> 1:4.5-2.mga9
+ Revision: 1744639
- rebuild for boost 1.77.0

* Fri Aug 06 2021 luigiwalser <luigiwalser> 1:4.5-1.mga9
+ Revision: 1739898
- 4.5

* Fri May 14 2021 wally <wally> 1:4.4-7.mga9
+ Revision: 1723024
- rebuild for boost 1.76.0

* Thu May 06 2021 tv <tv> 1:4.4-6.mga9
+ Revision: 1721660
- Rebuild for dyninst 11.0.0

* Sat Mar 20 2021 tv <tv> 1:4.4-5.mga9
+ Revision: 1705567
- rebuild for python-3.9.2

* Thu Dec 31 2020 wally <wally> 1:4.4-4.mga8
+ Revision: 1666823
- rebuild for boost 1.75.0

* Sun Dec 20 2020 wally <wally> 1:4.4-3.mga8
+ Revision: 1662065
- rebuild for boost 1.74.0

* Sun Nov 29 2020 luigiwalser <luigiwalser> 1:4.4-2.mga8
+ Revision: 1650349
- rebuild for json-c

* Tue Nov 10 2020 tv <tv> 1:4.4-1.mga8
+ Revision: 1644258
- 4.4

* Thu Sep 10 2020 tv <tv> 1:4.3-3.mga8
+ Revision: 1624066
- Rebuild for dyninst 10.2.0

* Wed Sep 09 2020 tv <tv> 1:4.3-2.mga8
+ Revision: 1623997
- Rebuild for dyninst 10.2.0

* Fri Jun 12 2020 tv <tv> 1:4.3-1.mga8
+ Revision: 1593050
- 4.3

* Sun May 03 2020 wally <wally> 1:4.2-5.mga8
+ Revision: 1578119
- rebuild for boost 1.73.0
+ danf <danf>
- Switch URLs from http: to https:

* Thu Feb 20 2020 umeabot <umeabot> 1:4.2-4.mga8
+ Revision: 1545436
- Mageia 8 Mass Rebuild

* Wed Jan 29 2020 mokraemer <mokraemer> 1:4.2-3.mga8
+ Revision: 1484743
- fixed missing files, macro expansion; rebuild for boost
+ wally <wally>
- rebuild for boost 1.72.0
- replace deprecated %%configure2_5x
+ tv <tv>
- split devel subpkg
- typo fix
- split runtime-virthost & sdt-devel subpkgs
- split testsuite package

* Sat Jan 04 2020 tv <tv> 1:4.2-2.mga8
+ Revision: 1476450
- fix ambiguous python shebangs
- rebuild for new readline

* Sat Nov 23 2019 tv <tv> 1:4.2-1.mga8
+ Revision: 1462263
- 4.2

* Sun Sep 15 2019 tv <tv> 1:4.1-3.mga8
+ Revision: 1441651
- drop python2 subpkg
- rebuild for python-3.8
- rebuild for rpm-4.15

* Tue Jul 02 2019 tv <tv> 1:4.1-1.mga8
+ Revision: 1417607
- new release
- rebuild for new dyninst

* Thu Feb 07 2019 wally <wally> 1:4.0-5.mga7
+ Revision: 1364033
- prefer python3

* Tue Jan 08 2019 tv <tv> 1:4.0-4.mga7
+ Revision: 1352000
- rebuild with python 3.7
- add runtime-virtguest subpkg

* Mon Oct 15 2018 tv <tv> 1:4.0-2.mga7
+ Revision: 1320389
- enable more features
- enable systemd support
- explicitely enable bpf
- new release

* Sun Sep 23 2018 umeabot <umeabot> 1:3.3-6.mga7
+ Revision: 1301297
- Mageia 7 Mass Rebuild

* Fri Jul 06 2018 pterjan <pterjan> 1:3.3-5.mga7
+ Revision: 1242380
- Restrict dyninst requirement to architectures where it is available

* Thu Jun 14 2018 daviddavid <daviddavid> 1:3.3-4.mga7
+ Revision: 1236919
- add missing epoch

* Thu Jun 14 2018 daviddavid <daviddavid> 1:3.3-3.mga7
+ Revision: 1236844
- fix requires

* Wed Jun 13 2018 tv <tv> 1:3.3-2.mga7
+ Revision: 1236736
- add python subpkgs
- new version

* Tue Jan 02 2018 wally <wally> 1:3.2-0.2.mga7
+ Revision: 1189474
- rebuild for new readline

* Fri Sep 08 2017 tv <tv> 1:3.2-0.1.mga7
+ Revision: 1151927
- new release (needed in order to fix qemu build with gcc7) [gcc#PR80115]

* Fri Sep 01 2017 tv <tv> 1:3.1-2.mga7
+ Revision: 1150528
- patch 2: fix build with new rpm
- rebuild for new rpm

* Tue Feb 21 2017 luigiwalser <luigiwalser> 1:3.1-1.mga6
+ Revision: 1087193
- 3.1

* Sat Feb 04 2017 daviddavid <daviddavid> 1:3.0-3.mga6
+ Revision: 1084796
- use new rpm macros thus fixing installation of all lang manpages

* Thu Aug 11 2016 luigiwalser <luigiwalser> 1:3.0-2.mga6
+ Revision: 1045940
- add patch from fedora with fixes for kernel 4.6
+ tv <tv>
- gtkmm2.4-devel & libglade2.0-devel are unneeded for years

* Mon Mar 28 2016 luigiwalser <luigiwalser> 1:3.0-1.mga6
+ Revision: 996040
- docs are pdf now
- html docs are not generated for now
- 3.0
- include patch from fedora to fix brown paper bag bug

* Sat Dec 26 2015 luigiwalser <luigiwalser> 1:2.9-1.mga6
+ Revision: 915478
- add systemtap beginners guide to doc list
- 2.9

* Sat Oct 10 2015 blino <blino> 1:2.6-6.mga6
+ Revision: 889400
- buildrequire xmlto and package html doc (build failed when xmlto was installed)

* Sun Sep 06 2015 tv <tv> 1:2.6-5.mga6
+ Revision: 873244
- submit to core/release

* Sun Aug 23 2015 tv <tv> 1:2.6-4.mga6
+ Revision: 868858
- fix "Installed (but unpackaged) file(s)"
- rebuild for rpm-4.13

* Wed Oct 15 2014 umeabot <umeabot> 1:2.6-3.mga5
+ Revision: 740900
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild

* Tue Sep 09 2014 luigiwalser <luigiwalser> 1:2.6-1.mga5
+ Revision: 674462
- 2.6

* Fri May 09 2014 luigiwalser <luigiwalser> 1:2.5-1.mga5
+ Revision: 621627
- 2.5

* Wed Dec 18 2013 luigiwalser <luigiwalser> 1:2.4-1.mga4
+ Revision: 558636
- 2.4
- fix /usr/share/systemtap directory permissions

* Tue Oct 22 2013 umeabot <umeabot> 1:2.3-5.mga4
+ Revision: 541512
- Mageia 4 Mass Rebuild

* Sat Oct 12 2013 dmorgan <dmorgan> 1:2.3-4.mga4
+ Revision: 496062
- Remove workaround now that java7 is fixed

* Sat Oct 12 2013 dmorgan <dmorgan> 1:2.3-3.mga4
+ Revision: 495974
- workaround java conflicts

* Thu Oct 10 2013 luigiwalser <luigiwalser> 1:2.3-2.mga4
+ Revision: 494426
- add BR texlive-texmf to try to fix build

* Fri Aug 09 2013 luigiwalser <luigiwalser> 1:2.3-1.mga4
+ Revision: 464828
- 2.3

* Wed Jul 24 2013 luigiwalser <luigiwalser> 1:2.2.1-1.mga4
+ Revision: 457521
- 2.2.1

* Mon Jan 14 2013 umeabot <umeabot> 1:2.0-4.mga3
+ Revision: 383985
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jan 06 2013 pterjan <pterjan> 1:2.0-3.mga3
+ Revision: 340115
- Fix for _libdir != _libexecdir
- Fix file list to own directories

* Tue Dec 18 2012 tv <tv> 1:2.0-2.mga3
+ Revision: 332390
- rebuild for new rpm

* Tue Dec 18 2012 tv <tv> 1:2.0-1.mga3
+ Revision: 332375
- drop obsolete CVE patch
- new release
- rebuild for new rpm

* Tue Jun 12 2012 tv <tv> 1:1.6-6.mga3
+ Revision: 259950
+ rebuild (emptylog)

* Sun Jun 10 2012 tv <tv> 1:1.6-5.mga3
+ Revision: 259377
- rebuild for new rpm-4.10.0

* Mon Apr 09 2012 luigiwalser <luigiwalser> 1:1.6-4.mga2
+ Revision: 230000
- fix CVE-2012-0875 (from redhat)

* Tue Dec 20 2011 dmorgan <dmorgan> 1:1.6-3.mga2
+ Revision: 185014
- Rebuild against rpm 4.9.1.2

* Tue Oct 18 2011 dmorgan <dmorgan> 1:1.6-2.mga2
+ Revision: 156307
- Add rpm-devel as buildrequires
- Add rpm support

* Tue Oct 18 2011 dmorgan <dmorgan> 1:1.6-1.mga2
+ Revision: 156102
- New version 1.6

* Fri Sep 09 2011 tv <tv> 1:1.4-1.mga2
+ Revision: 141642
- new release
- sync patches with fedora
- drop buildroot
+ rtp <rtp>
- disable systemtap on mips as it's not supported

* Wed Jan 12 2011 ahmad <ahmad> 1:1.3-1.mga1
+ Revision: 7722
- imported package systemtap


* Fri Aug 06 2010 trem <trem@mandriva.org> 1:1.3-1mdv2011.0
+ Revision: 566922
- update to 1.3
- update Buildrequires

* Thu Mar 25 2010 trem <trem@mandriva.org> 1:1.2-1mdv2010.1
+ Revision: 527315
- update to 1.2
- remove patch systemtap-1.1-get_argv.patch (added upstream)
- remove patch systemtap-1.1-cfi-cfa_ops-fixes.patch (added upstream)
- remove patch systemtap-1.1-tighten-server-params.patch (added upstream)

* Thu Feb 25 2010 Oden Eriksson <oeriksson@mandriva.com> 1:1.1-2mdv2010.1
+ Revision: 511042
- sync with systemtap-1.1-2.fc13.src.rpm
- P1: security fix for CVE-2010-0411
- P2: security fix for CVE-2010-0412, CVE-2009-4273

  + trem <trem@mandriva.org>
    - update to 1.1
    - remove patch p0, p1 and p2 (CVE-2009-2911) (added upstream)

* Fri Oct 23 2009 Frederic Crozat <fcrozat@mandriva.com> 1:1.0-3mdv2010.0
+ Revision: 459091
- Force rebuild

  + Frederik Himpe <fhimpe@mandriva.org>
    - Add Fedora patches to fix CVE-2009-2911

* Wed Sep 23 2009 Eugeni Dodonov <eugeni@mandriva.com> 1:1.0-1mdv2010.0
+ Revision: 447869
- Updated to 1.0.

* Wed Aug 05 2009 trem <trem@mandriva.org> 1:0.9.9-1mdv2010.0
+ Revision: 410267
- update to 0.9.9

* Fri Jun 12 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1:0.9.8-1mdv2010.0
+ Revision: 385378
- Updated to version 0.9.8

* Tue May 12 2009 trem <trem@mandriva.org> 0.20090429.1-1mdv2010.0
+ Revision: 375054
- update to 20090429 (0.9.7)
- update to 0.8
- clean .spec (remove useless patch)

* Tue Oct 14 2008 Luiz Fernando Capitulino <lcapitulino@mandriva.com> 0.20081013.1-1mdv2009.1
+ Revision: 293675
- Update to 2008-10-13 version, because of changes in the kernel API

* Wed Jul 09 2008 trem <trem@mandriva.org> 0.20080705.1-1mdv2009.0
+ Revision: 233150
- update to 20080705

* Mon Jul 07 2008 Oden Eriksson <oeriksson@mandriva.com> 0.20080614.1-2mdv2009.0
+ Revision: 232373
- rebuilt against new libcap

* Fri Jun 20 2008 trem <trem@mandriva.org> 0.20080614.1-1mdv2009.0
+ Revision: 227507
- remove useless BuildRequires
- add patches to fix configure (Underlinking problems)
- add Buildrequires:elfutils-devel
- update to 20080614

* Sun May 18 2008 trem <trem@mandriva.org> 0.20080517.1-1mdv2009.0
+ Revision: 208699
- update to 20080517:x
- add testsuite (include some example)

* Sat May 10 2008 trem <trem@mandriva.org> 0.20080510.1-1mdv2009.0
+ Revision: 205404
- update to 20080510
- update to 20080315

* Sun Feb 17 2008 trem <trem@mandriva.org> 0.20080216.1-1mdv2008.1
+ Revision: 170043
- update to 20080216

* Sun Feb 10 2008 trem <trem@mandriva.org> 0.20080209.1-1mdv2008.1
+ Revision: 164875
- update to 20080209

* Sun Jan 27 2008 trem <trem@mandriva.org> 0.20080126.1-1mdv2008.1
+ Revision: 158876
- update to 20080126

* Sun Jan 27 2008 trem <trem@mandriva.org> 0.20080112.1-2mdv2008.1
+ Revision: 158778
- update to 20080112

* Sun Jan 27 2008 trem <trem@mandriva.org> 0.20071208.1-2mdv2008.1
+ Revision: 158756
- fix provide (don't request a lib that don't exist)

* Thu Jan 03 2008 trem <trem@mandriva.org> 0.20071208.1-1mdv2008.1
+ Revision: 143564
- add elfutils-static-devel as buildrequires
- add elfutils and libcap-devel as buildrequires
- add libelfutils-devel as builrequires
- add libcap-devel as Buildrequires
- import systemtap


* Sun Dec  9 2007  <trem@mandriva.org> 0.20071208.1-1mdv2008.1
- Initial build.
